<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form [formGroup]="secureMailServerForm" class="ls-form">

  <div class="modal-header">
    <h4
      class="modal-title overflow-hidden text-overflow-ellipsis text-nowrap"
      id="modal-basic-title"
      [innerText]="messages.getConnectorEditOrCreatePopupTitle(editMode, currentServer?.name)">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body mt-4 mx-3">


    <div class="form-group required">
      <label for="nameInput" [innerText]="commonMessages.NAME"></label>
      <input
        [(ngModel)]="currentServer.name"
        id="nameInput"
        name="nameInput"
        type="text"
        class="form-control"
        formControlName="name">
    </div>

    <div class="form-group required">
      <label for="urlInput" [innerText]="messages.URL"></label>
      <input
        [(ngModel)]="currentServer.url"
        id="urlInput"
        name="urlInput"
        type="text"
        class="form-control"
        formControlName="url">
    </div>

    <div class="form-group required">
      <label for="loginInput" [innerText]="messages.LOGIN"></label>
      <input
        [(ngModel)]="currentServer.login"
        id="loginInput"
        name="loginInput"
        type="text"
        class="form-control"
        formControlName="login">
    </div>

    <div class="form-group required">
      <label for="passwordInput" [innerText]="commonMessages.PASSWORD"></label>
      <div class="input-group">

        <input
          [(ngModel)]="currentServer.password"
          [type]="hidePassword ? 'password' : 'text'"
          id="passwordInput"
          name="passwordInput"
          class="form-control"
          formControlName="password">

        <div
          class="input-group-text pointer"
          (click)="hidePassword = !hidePassword">
          <fa-icon
            class="hide-password-button text-center"
            [icon]="hidePassword ? eyeIcon : eyeSlashIcon"
            [fixedWidth]="true">
          </fa-icon>
        </div>
      </div>

    </div>

    <div class="d-flex flex-row align-items-center">
      <button
        [text]="connected ? messages.DISCONNECT : messages.CONNECT"
        [processing]="isProcessing"
        [style]="connected ? style.WARNING : style.NORMAL"
        (click)="connect()"
        [icon]="plugIcon"
        [disabled]="!secureMailServerForm.valid"
        ls-button
        class="me-2">
      </button>

      <span [ngClass]="{'text-success': connected && !connectionError, 'text-danger': !connected && connectionError }">
        <fa-icon *ngIf="connected" [icon]="commonIcons.VALIDATED_ICON"></fa-icon>
        <fa-icon *ngIf="connectionError" [icon]="commonIcons.REJECTED_ICON"></fa-icon>
        <span class="ms-1" [innerText]="getConnectionMessage()"></span>
      </span>
    </div>

    <ng-select
      [(ngModel)]="currentServer.entity"
      [notFoundText]="commonMessages.NOT_FOUND"
      [multiple]="false"
      [clearable]="true"
      [clearAllText]="commonMessages.CLEAR"
      [disabled]="!connected"
      [placeholder]="messages.CHOOSE_AN_ENTITY"
      bindLabel="name"
      class="input-group ls-select mt-3"
      id="validator"
      selectOnTab
      formControlName="entity">

      <ng-option
        *ngFor="let entity of entities"
        [value]="entity.id"
        [innerText]="entity.name">
      </ng-option>

    </ng-select>
  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
    <button
      ls-button-save
      [processing]="isProcessing"
      (click)="executeForm()"
      [text]="editMode ? commonMessages.EDIT : commonMessages.ADD"
      [icon]="editMode ? commonIcons.EDIT_ICON : commonIcons.ADD_ICON"
      [disabled]="!secureMailServerForm.valid || !connected || !currentServer?.entity">
    </button>
  </div>

</form>
